//*************************************************
// 01.02.2016
// mega8
//  RC- 8.0000Mhz 
// startcd@narod.ru .
//
// http://startcd.narod.ru/ 
//
//*************************************************

#include "pin_macros.h"

#define	miganie //  ,       .


#define F_ 		   (key==1)
#define SET_ 	   (key==2)
#define PLUS 	   (key==3)
#define MINUS	   (key==4)
//------------------------------
#define KL_F		C,3,L 
#define KL_SET		C,2,L 
#define KL_PLUS		C,1,L 
#define KL_MINUS	C,0,L 

//---------------74HC595--------------
#define DATA_595	B,5,H
#define SHIFT		B,4,H
#define STORAGE		B,3,H
//-------OC1A---------
#define OC1A		_BV(1)
#define DDR_OC1A	DDRB
//---------1WIRE-------------
#define	PORT_1wire 		PORTD
#define	DDR_1wire 		DDRD
#define	PIN_1wire 		PIND
#define	PWIRE0 			_BV(1)	//PC3	
#define	PWIRE1 			_BV(2)	//PC4	
//--------OUTS-----------------
#define CALLS_OSN		D,0,H
#define CALLS_NAGRUZ	B,0,H
#define TIMER_PIN		B,2,H//-----------------------------------<
//--------/ ------------
#define EXT_POWER		D,7,L
//--------Humidy---------------------------


//-------- time_flag byte -------
#define FL_SEK_1_SWITCH			_BV(0)
#define	FL_PLUS					_BV(1)//  
#define	FL_SIG_BUTT				_BV(2)//    
#define	FL_POWER_INIT_DEVICE 	_BV(3)
#define	FL_SIGNAL_OUT_ENABLE	_BV(4)
#define FL_SIGNAL_CLS		 	_BV(5)
#define FL_SIG_OTSR				_BV(6)
#define FL_CALLS_PIN_A_ON	 	_BV(7)

//----------- time_1w_flag ---
#define FL_PARASITE_POWER		_BV(7)
#define FL_SHT10_ERR			_BV(0)
#define FL_SHT10_READY			_BV(1)

//----------timer[3]----------
#define FL_TIMER_COUNT		 0//  _BV()!   . inc_dec_var_bit()!

//----------------------------
#define	H_SEK		0//
#define	H_MIN		1
#define	H_HOUR		2
#define	H_DAY 		3
#define	H_NUM		4
#define	H_MONTH		5
#define	H_YEAR		6
#define	C_MIN		1// 
#define C_HOUR		2
#define C_DAY		3
#define C_SIG		0

//----------corr_flag---------
#define FL_CORR_ZNAK_PL	0

#define DS0	0
#define DS1	1

#define true	1
#define false	0

//---time[]---
#define WIRE1		0
#define NOTE		1
#define NOTE_BUT	2
#define BEG_STR		3

#define SIG_ON_OTSR		1	// == 1   
#define SIG_ON			2	// == 2   
#define SIG_ODINRAZ		3	// == 3  
#define SIG_FOREVER		4	// == 4  
#define SIG_TIMER 		SIG_ON	// == 2    

uint8_t time_flag, regim;
uint8_t key, znakomesto, lcd_time_switch, time_in_regim, change_light, lcd_light=5, anti_drebezg[3];
unsigned char tempir_lsb[2], tempir_msb[2], out_1wire, time_1w_flag, count_com_1w, power_suplly_1w;
  signed char time[4], timer[4], TimerTime[3], TimeMeasureDs18B20;
unsigned int  mask;
unsigned char clock_, isr_1sek_, hour[7]={0,0,12,0,0,0,16};//hour- year,month,num,day,hour,min,sek
unsigned char budilnik_nomer, simvol, budilnik_play_num, nedelia[2];
uint16_t time_bud_pin;
unsigned char lcd_buffer[10], bcd_num0, bcd_num1, bcd_num2, bcd_num3, bcd_num4;
unsigned char signal, time_signal, count_note, p_index;
uint8_t eeprom_err;	

#define USR_PRESS_MIN_TIME	16// 
#define USR_PRESS_MAX_TIME	16
uint16_t pressure_massiv_min[USR_PRESS_MIN_TIME];//max value 65535/800=~80    80*2=160
uint16_t pressure_massiv_max[USR_PRESS_MAX_TIME];	

uint8_t light_isr, light_disp[]={55,50,45,35,25,17,14,9,3}, light_time_mig[]={10,9,8,8,7,5,4,4,3};//{1,3,5,10,15,20,24,27};
//{28,26,24,21,18,15,10,5,2}
#define	OCR1AHI			0
#define	OCR1ALOW		1
#define	OCR1AHI_BUT		2
#define	OCR1ALOW_BUT	3

							
// callnomer-5 hour-7,8 min-10,11
uint8_t *ukaz_na_str, correct;
prog_int16_t	corr_in_lcd[51] =	{0,8,16,23,31,39,47,55,63,70,78,86,94,102,109,117,
									125,133,141,148,156,164,172,180,188,195,203,211,219,227,234,242,
									250,258,266,273,281,289,297,305,313,320,328,336,344,352,359,367,
									375,383,391};

const uint8_t 	num_in_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};
const uint8_t  uprav_TCCR1B[4]={1|(1<<WGM12), 0|(1<<WGM12), 1|(1<<WGM12), 0|(1<<WGM12)};
const int8_t length_note[4]={20,10,20,75};
struct	setup {
		uint8_t day_light;
		uint8_t night_light;
		uint8_t tim_c_light;
		uint8_t tim_do_light;
		
		uint8_t budilnik[12][4];
		uint8_t budil_pin[2][3];
		uint8_t signal_bud;
		uint8_t ocr1[4];
		
		#define Count_regim	8//  
		#define num_formats	23//   ,     . view_in_indikator()
		uint8_t state_time [Count_regim];
		uint8_t state_regim[Count_regim];
		uint8_t state_skip [Count_regim];
		uint8_t vid_t;
		uint8_t corr_flag;
		uint8_t correction;
		int8_t corrDs[2];
		uint16_t crc;
} setup;

struct current_state_view
{
	uint8_t regim;
	uint8_t time;
	uint8_t skip[Count_regim];
	uint8_t viewstate;
}	current_state_view;
	



